'use strict';

// load dependencies
var $ = window.$ = window.jQuery = require('jquery');
var animationControl = require('./animation-control.js');
var LineMove = require('../../../common/src/javascripts/line-move');
var resourceLoader = require('../../../common/src/javascripts/resource-loader.js');
var prefix = 'http://static.leanote.top/ttxd/';
var version = 11;
var cdkWbg2 = getCookie('ttxd-cdk2-wbg');
var cdkSxs2 = getCookie('ttxd-cdk2-sxs');
var finished = false;
var first = true;
var finishedFirst = false;
if (cdkWbg2 && cdkSxs2) {
	finished = true;
	finishedFirst = true;
	first = false;
}
var resouces = [
	'images/loading.png',
	'images/musicClose.png',
	'images/musicOpen.png',
	'images/share_logo.jpg',
	'images/headpage/LOGO.png',
	'images/headpage/backgrund.jpg',
	'images/headpage/btn.png',
	'images/headpage/clouds.png',
	'images/mianpage/background.jpg',
	'images/mianpage/floating.png',
	'images/mianpage/head-img.png',
	'images/mianpage/floatWindow/1.png',
	'images/mianpage/floatWindow/2.png',
	'images/mianpage/floatWindow/3.png',
	'images/mianpage/floatWindow/4.png',
	'images/mianpage/floatWindow/5.png',
	'images/mianpage/floatWindow/9.png',
	'images/mianpage/floatWindow/10.png',
	'images/mianpage/floatWindow/8.png',
	'images/mianpage/floatWindow/btn.png',
	'images/mianpage/floatWindow/btn1.png',
	'images/mianpage/floatWindow/btn2.png',
	'images/mianpage/floatWindow/CDK3.png',
	'images/mianpage/floatWindow/dropOut.png',
	'images/mianpage/floatWindow/foodcoupons.png',
	'images/mianpage/diceShadow/shadow1.png',
	'images/mianpage/diceShadow/shadow2.png',
	'images/mianpage/diceShadow/shadow3.png',
	'images/mianpage/diceShadow/shadow4.png',
	'images/mianpage/diceShadow/shadow5.png',
	'images/mianpage/dice4/1.png',
	'images/mianpage/dice4/2.png',
	'images/mianpage/dice4/3.png',
	'images/mianpage/dice4/4.png',
	'images/mianpage/dice4/5.png',
	'images/mianpage/dice5/1.png',
	'images/mianpage/dice5/2.png',
	'images/mianpage/dice5/3.png',
	'images/mianpage/dice5/4.png',
	'images/mianpage/dice5/5.png',
	'images/mianpage/dice6/1.png',
	'images/mianpage/dice6/2.png',
	'images/mianpage/dice6/3.png',
	'images/mianpage/dice6/4.png',
	'images/mianpage/dice6/5.png',
	'images/tip.png',
	'images/rule.png',
	'images/rule_btn.png',
	'images/explain.png'
];
var genNonceStr = function (len) {
	var str = "";
	var arr = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
	var pos;

	for (var i = 0; i < (len || 16); i++) {
		pos = Math.round(Math.random() * (arr.length - 1));
		str += arr[pos];
	}
	return str;
};
var nonceStr = genNonceStr(16);
var timeStr = Math.floor(new Date().getTime() / 1000);

function getSign(data, successCb) {
	wx.config({
		// 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
		debug: false,
		// 必填，公众号的唯一标识
		appId: 'wx888048ccfc4491c8',
		// 必填，生成签名的时间戳
		timestamp: timeStr,
		// 必填，生成签名的随机串
		nonceStr: nonceStr,
		// 必填，签名，见附录1
		signature: data['sign'],
		// 必填，需要使用的JS接口列表，所有JS接口列表见附录2
		jsApiList: [
			'onMenuShareTimeline',
			'onMenuShareAppMessage'
		]
	});
	wx.error(function (res) {
		// config信息验证失败会执行error函数，如签名过期导致验证失败，具体错误信息可以打开config的debug模式查看，也可以在返回的res参数中查看，对于SPA可以在这里更新签名。
		// alert(JSON.stringify(res));
	});

	successCb && successCb();
}


function setCookie(name, value) {
	var Days = 30;
	var exp = new Date();
	exp.setTime(exp.getTime() + Days * 24 * 60 * 60 * 1000);
	document.cookie = name + "=" + escape(value) + ";expires=" + exp.toGMTString();
}

function getCookie(name) {
	var arr, reg = new RegExp("(^| )" + name + "=([^;]*)(;|$)");
	if (arr = document.cookie.match(reg))
		return unescape(arr[2]);
	else
		return null;
}
// set wx flag
$.ajax({
	'url': 'http://jishub.com/api/siteSign',
	'dataType': 'json',
	'data': {
		url: window.location.href.split('#')[0],
		noncestr: nonceStr,
		timestamp: timeStr
	},
	success: function (data) {
		//console.log(data);
		getSign(data, function () {
			// TODO
			wx.ready(function () {
				setCookie('wx', true);
				wx.onMenuShareTimeline({
					title: '勇者们，探险的时候到了，快来开启你的冒险之旅', // 分享标题
					link: 'http://starnet-social.teakki.top/ttxd', // 分享链接
					imgUrl: prefix + 'images/share_logo.jpg', // 分享图标
					success: function () {
						// 用户确认分享后执行的回调函数
						// alert('success');
					},
					cancel: function () {
						// 用户取消分享后执行的回调函数
						//alert('cancel')
					}
				});
				wx.onMenuShareAppMessage({
					title: '海牙岛冒险之旅', // 分享标题
					link: 'http://starnet-social.teakki.top/ttxd', // 分享链接
					imgUrl: prefix + 'images/share_logo.jpg', // 分享图标
					desc: '勇者们，探险的时候到了，快来开启你的冒险之旅', // 分享描述
					type: '', // 分享类型,music、video或link，不填默认为link
					dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
					success: function () {
						// 用户确认分享后执行的回调函数
						//alert('success');
					},
					cancel: function () {
						// 用户取消分享后执行的回调函数
						//alert('cancel');
					}
				});
			});
		});
	},
	error: function () {
	},
	timeout: function () {
	}
});

var isRule = false;
$(document).ready(function () {
	$('.swiper-container').css('zoom', Math.min($(document.body).width(), $(document.body).height()) / 640);
	var bgMusic = $('audio').get(0);
	var $btnMusic = $('.btn-music');

	// background music control
	$btnMusic.click(function () {
		if (bgMusic.paused) {
			bgMusic.play();
			$(".btn-music i").addClass("played").removeClass("paused");
		} else {
			bgMusic.pause();
			$(".btn-music i").removeClass("played").addClass("paused");
		}
	});

	// init Swiper
	var swiper = new Swiper('.swiper-container', {
		mousewheelControl: false,
		effect: 'slide', // slide, fade, coverflow or flip
		speed: 400,
		direction: 'vertical',
		fade: {
			crossFade: false
		},
		initialSlide: finished?1:0,
		coverflow: {
			rotate: 100,
			stretch: 0,
			depth: 300,
			modifier: 1,
			slideShadows: false // do disable shadows for better performance
		},
		flip: {
			limitRotation: true,
			slideShadows: false // do disable shadows for better performance
		},
		onInit: function (swiper) {
			animationControl.initAnimationItems(); // get items ready for animations
			animationControl.playAnimation(swiper); // play animations of the first slide
		},
		onTransitionEnd: function (swiper) { // play animations of the current slide
			animationControl.playAnimation(swiper);
		}
		/*onTouchStart: function(swiper, event) { // mobile devices don't allow audios to play automatically, it has to be triggered by a user event(click / touch).
		 if(!$(".btn-music i").hasClass('paused') || bgMusic.paused) {
		 bgMusic.play();
		 }
		 }*/
	});

	function checkViewport(argument) {
		if (document.body.offsetWidth > document.body.offsetHeight && document.body.offsetWidth > 400) {
			$('.rotate-overlay').show();
		} else {
			$('.rotate-overlay').hide();
			// $('.swiper-container').css('zoom', $(document.body).width() / 320);
			$('.swiper-container').css('zoom', Math.min($(document.body).width(), $(document.body).height()) / 640);
			swiper.updateSlidesSize();
		}
	}
	$(window).resize(function () {
		setTimeout(function () {
			checkViewport();
		}, 100);
	});
	checkViewport();
	// hide loading animation since everything is ready
	$(".item-btn").click(function () {
		$(".yun_up").addClass("cloudsRight");
		$(".yun_down").addClass("cloudsLeft");
		util.tracking('start');
		setTimeout(function () {
			swiper.slideTo(1, 0);
			$(".yun_up").removeClass("cloudsRight").addClass("cloudsLeft2");
			$(".yun_down").removeClass("cloudsLeft").addClass("cloudsRight2");
		}, 3000)
	});
	$('.rule-btn').click(function () {
		if (!role.isMoving()) {
			isRule = true;
			$(".swiper-slide").removeClass("overflow-scr");
			$('.floating-window').show();
			$('#rule').show().siblings().hide();
		}
	});
	resourceLoader.loadImages(resouces, function (over, count, length, map, percent, fakePercent) {
		console.log(over, count, length, percent);
		if(over) {
			bgMusic.play();
			$(".progress").html('100%');
			setTimeout(function () {
				$('.loading-overlay').slideUp();
				if (finished) {
					//console.log(cdkSxs2, cdkWbg2);
					$('.cdk1-infor').html(cdkWbg2);
					$('.cdk2-infor').html(cdkSxs2);
					$(".cdk3").show().siblings().hide();
					$('.input-dropout').show();
					$('.cdk1-infor').show();
					$('.cdk2-infor').show();
					$(".foodcoupons-btn").show();
					$(".btns").show();
					$(".swiper-slide").removeClass("overflow-scr");
					$('.floating-window').show();
				}
				else if (first) {
					$('.rule-btn').trigger('click');
				}
			}, 1000);
		} else {
			$(".progress").html(percent + '%');
		}
	}, 2000, 50, prefix, version);
	var pointMap = {fromCss: true};
	var pointChain = 'point1 point4 point5 point7 point8-l point8-h point9-h point9-l point9 point10-l point10-h point11 point12 point13 point13-l point13-h point14-h point14-l point15 point17 point19 point20-l point20-h point21-h point21-l point22 point23 point25 point25-l point25-h point26-h point26-l point28 point29 point30';
	var role = new LineMove('#target', pointChain, pointMap, 'point1', 3);
	$('.point').on('click', function () {
		var point = 'point' + $(this).html();
		role.moveTo(point);
	});
	var a = [4, 5, 6, 4, 6]; //根据骰子来设置的移动步数
	var c = [4, 7, 12, 15, 19, 23, 28, 30]; //需要弹窗的point值
	var d = [3, -3, 4, -1, 2]; //根据浮图来确定的移动步数
	var e = [4, 12, 15, 23, 28]; //根据浮图来确定的移动步数的point值
	var f = [1, 7, 9, 19, 22]; //使用骰子来移动的point值
	var clen = c.length;
	var elen = e.length;
	var flen = f.length;
	var currentCount = 0;
	var b = 0;
	var img = $(".dice img");
	var len = img.length;
	var mark = false;
	var util = {
		tracking: function (log) {
			console.log(log, b);
			window._czc.push(['_trackEvent', log, log, log, log, log]);
		},
		getCDKValue1: function (callback) {
			var cdkWbg = getCookie('ttxd-cdk2-wbg');
			if (cdkWbg) {
				$('#cdkone').html(cdkWbg);
				$('.cdk1-infor').html(cdkWbg);
				setTimeout(function () {
					callback && callback(cdkWbg);
				}, 500);
			} else {
				$.ajax({
					type: "GET",
					url: "/ttxd/fetchCDKCWBG",
					data: {
						openId: window.openId
					},
					contentType: "application/json; charset=utf-8",
					dataType: "json",
					success: function (data) {
						// Play with returned data in JSON format
						if (data.success && data.cdk) {
							$('#cdkone').html(data.cdk);
							$('.cdk1-infor').html(data.cdk);
							setCookie('ttxd-cdk2-wbg', data.cdk);
						}
						callback && callback(data.cdk);
					},
					error: function (msg) {
						console.log(msg);
					}
				});
			}
		},
		getCDKValue2: function (callback) {
			var cdksxs = getCookie('ttxd-cdk2-sxs');
			if (cdksxs) {
				$('#cdktwo').html(cdksxs);
				$('.cdk2-infor').html(cdksxs);
				setTimeout(function () {
					callback && callback(cdksxs);
				}, 500);
			} else {
				$.ajax({
					type: "GET",
					url: "/ttxd/fetchCDKSXS",
					data: {
						openId: window.openId
					},
					contentType: "application/json; charset=utf-8",
					dataType: "json",
					success: function (data) {
						// Play with returned data in JSON format
						if (data.success && data.cdk) {
							$('#cdktwo').html(data.cdk);
							$('.cdk2-infor').html(data.cdk);
							setCookie('ttxd-cdk2-sxs', data.cdk);
						}
						callback && callback(cdk);
					},
					error: function (msg) {
						console.log(msg);
					}
				});
			}
		}
	};
	/*点击头像事件*/
	$('#target').click(function () {
		if (b === 30) {
			//no do
		} else if (role.isMoving()) {
			//no do
		} else {
			var index = 0;
			var dsdimg = $(".dice-shadow img");
			for (var i = 0; i < elen; i++) {
				if (b == f[i]) {
					$(".dicecount span").html("【前进" + a[i] + "步】");
					for (var n = 0; n < len; n++) {
						$(".dice img:eq(" + n + ")").attr("src", prefix + "images/mianpage/dice" + a[i] + "/" + (n + 1) + ".png?version=" + version);
					}
				}
			}
			$(".swiper-slide").removeClass("overflow-scr");
			//$('.back-ground2').next().removeClass("hiddeen").addClass("showed");
			$('.back-ground2').next().show();
			var dic = setInterval(function () {
				if (index < len) {
					img.eq(index).show().siblings().hide();
					dsdimg.eq(index).show().siblings().hide();
					index++;
				}
				if (index == len) {
					mark = true;
					clearInterval(dic);
					setTimeout(function () {
						var floatingDice = $('.floating-dice');
						var isVisible = floatingDice.is(':visible');
						if (isVisible) {
							floatingDice.trigger('click');
						}
					}, 1000);
				}
			}, 200);
		}
	});
	/*退出骰子界面*/
	$(".floating-dice").click(function () {
		if (mark) {
			b += a[currentCount];
			$(".swiper-slide").addClass("overflow-scr");
			$('.back-ground2').next().hide();
			if (b === 4) {
				util.getCDKValue1();
			}
			else if (b === 15) {
				util.getCDKValue2();
			}
			var point = 'point' + b;
			currentCount++;
			role.moveTo(point);
			setTimeout(function () {
				for (var i = 0; i < clen; i++) {
					if (b == c[i]) {
						$(".swiper-slide").removeClass("overflow-scr");
						$('.floating-window').show();
						$(".window img").eq(i).show().siblings().hide();
						break;
					}
				}
			}, Math.abs(a[currentCount - 1]) * 400);
			mark = false;
		}
	});
	/*点击任意位置退出浮窗界面*/
	$('.floating-window').click(function () {
		if (finishedFirst) {
			return;
		}
		if (b === 4) {
			util.tracking('1sealyra');
		}
		else if (b === 7) {
			util.tracking('quitcdk1');
		}
		else if (b === 19) {
			util.tracking('quitcdk2');
		}
		else if (b === 12) {
			util.tracking('2crab');
		}
		else if (b === 15) {
			util.tracking('3bluedragon');
		}
		else if (b === 23) {
			util.tracking('4warrior');
		}
		else if (b === 28) {
			util.tracking('5captainjack');
		}
		if (isRule) {
			$(".swiper-slide").addClass("overflow-scr");
			$(this).hide();
			$('.input-dropout').hide();
			$(".window img").hide();
			isRule = false;
			if (first) {
				first = false;
				$('.mask').click(function () {
					$(this).fadeOut();
				}).fadeIn();
			}
		}
		else if (b === 30) {
			//todo
		} else {
			$(".swiper-slide").addClass("overflow-scr");
			//$('.back-ground2').next().next().removeClass("showed").addClass("hiddeen");
			$('.back-ground2').next().next().hide();
			//$('.dropout').hide();
			for (var i = 0; i < elen; i++) {
				if (b == e[i]) {
					b = b + d[i];
					var point = 'point' + b;
					role.moveTo(point);
					setTimeout(function () {
						for (var i = 0; i < clen; i++) {
							if (b == c[i] && !role.isMoving()) {
								$(".swiper-slide").removeClass("overflow-scr");
								//$('.back-ground2').next().next().removeClass("hiddeen").addClass("showed");
								$('.back-ground2').next().next().show();
								$(".window img").eq(i).show().siblings().hide();
								break;
							}
						}
					}, Math.abs(d[i]) * 400);
					switch (b) {
						/*case 7:
							//$('.dropout').show();
							$('#cdkone').show();
							break;
						case 19:
							//$('.dropout').show();
							$('#cdktwo').show();
							break;*/
						case 30:
							$('.item-input').show();
							$('.item-input .btns').hide();
							$('.item-input .foodcoupons-btn').hide();
							$(".item-input .btn2").show();
						default:
							//$('.dropout').hide();
							$('.cdk-infor').hide();
							break;
					}
				}
			}
		}
	});
	/*cdk关闭按钮事件*//*
	$(".dropout").click(function () {
		if (b === 7) {
			util.tracking('quitcdk1');
		}
		else if (b === 19) {
			util.tracking('quitcdk2');
		}
		$(this).hide();
		$(".swiper-slide").addClass("overflow-scr");
		//$('.back-ground2').next().next().removeClass("showed").addClass("hiddeen");
		$('.back-ground2').next().next().hide();
	});*/
	/*btn2按钮事件*/
	$(".item-input .btn2").click(function () {
		if(b === 30 && !isRule) {
			util.tracking('checkaward');
		}
		$(".cdk3").show().siblings().hide();
		$('.input-dropout').show();
		$(this).hide();
		$('.cdk1-infor').show();
		$('.cdk2-infor').show();
		$(".foodcoupons-btn").show();
		$(".btns").show();
	});
	/*.input-dropout点击事件*/
	$(".input-dropout").click(function () {
		//$('.back-ground2').next().next().removeClass("showed").addClass("hiddeen");
		$('.back-ground2').next().next().hide();
		$('.item-input').hide();
		$('.cdk3').hide();
		$('.cdk1-infor').hide();
		$('.cdk2-infor').hide();
		$(this).hide();
		$(".swiper-slide").addClass("overflow-scr");
		finishedFirst = false;
	});
	$(".game").click(function () {
		util.tracking('Togame');
	});
	$('.foodcoupons').click(function () {
		util.tracking('tocoupon');
	});
	/*再玩一次*/
	$(".play").click(function () {
		util.tracking('Again');
		$('.input-dropout').hide();
		finishedFirst = false;
		$(".foodcoupons-btn").hide();
		$('.cdk1-infor').hide();
		$('.cdk2-infor').hide();
		$(".btns").hide();
		$('.back-ground2').next().next().hide();
		$(".swiper-slide").addClass("overflow-scr");
		$('#target').removeAttr("style");
		$(".dicecount span").html("【前进4步】");
		for (var n = 0; n < len; n++) {
			$(".dice img:eq(" + n + ")").attr("src", prefix + "images/mianpage/dice4/" + (n + 1) + ".png?version=" + version);
		}
		currentCount = 0;
		b = 0;
		role = new LineMove('#target', pointChain, pointMap, 'point1', 3);
	});

});